#!/usr/bin/python
# -*- coding: koi8-r -*-
"""Docinfo file generator for ALT Linux Docs Team.

Syntax: pyhton docinfo_gen [options]

Options:
-f, --file [filename]		output docinfo file
-h, --help			display this help and exit
-v, --version			output version information and exit

Help:
In program directory you can find README file.

Written by Dmitri Alenitchev. Send comments to alenitchev@nm.ru"""
#   
import sys, getopt, string, config

i = 0
#  main:       gendocinfo()
def main(argv=None):
	if argv is None:
		argv = sys.argv
	#   
	try:
		opts, args = getopt.getopt(argv[1:], "hf:v", ["help", "file", "version"])
	except getopt.error, msg:
		print msg
		print "    --help"
		sys.exit(2)
	#  
	for o, a in opts:
		if o in ("-h", "--help"):
			print __doc__
			sys.exit(0)
		if o in ("-f", "--file"):
			gendocinfo(a)
		if o in ("-v", "--version"):
			print '  ALT Linux Docs Team Policy  0.0.9'
			sys.exit(0)
	#     
	gendocinfo()

# ,  .    ,   - docinfo
def gendocinfo(file='docinfo'):
	print '    : ' + file + '\n'
	#  ,    ,  
	docinfo  = open(file, 'w')
	# : 
	counter = 0 
	counterYN = 0
	counterTrue = 0
	counterLang = 0
	counterLic = 0
	counterAut = 0
	#            
	while counter != len(config.quest):
		#  
		answ = raw_input(config.quest[counter])
		#   
		if counter == 1:
			if answ in ('en', 'ru', 'uk'):
				docinfo.write(config.record[counter] + answ + '\n')
			else:
				if counterLang > 1:
					sys.exit(0)
				else:
					print '    : en, ru, uk!'
					counter = counter - 1
					counterLang = counterLang + 1
		# () 
		elif counter == 2:
			if answ != '':
                                docinfo.write(config.record[counter] + answ + '\n')
				aut = raw_input('    [y/n]? ')
				if aut in ('y', 'yes', 'Y', '', '', ''):
					counter = counter - 1
				elif aut in ('n', 'no', 'N', '', '', ''):
                                        pass
				else:
					print ' !'
                        else:
                                if counterAut > 1:
                                        sys.exit(0)
                                else:
                                        print '    !   !'
                                        counter = counter - 1
                                        counterAut = counterAut + 1
		# 
		elif counter == 4:
			if answ in ('GPL', 'FDL', 'distributable'):
				docinfo.write(config.record[counter] + answ + '\n')
			else:
				if counterLic > 1:
					sys.exit(0)
				else:
					print '    : GPL, FDL, distributable!'
					counter = counter - 1
					counterLic = counterLic + 1
		#   :  " "
		elif counter in (3, 5):
			if answ != '':
				docinfo.write(config.record[counter] + answ + '\n')
			else:
				pass
		#  
		elif counter == 6:
                        if answ != '':
                                docinfo.write(config.record[counter] + answ + '\n')
                                add = raw_input('    [y/n]? ')
                                if add in ('y', 'yes', 'Y', '', '', ''):
                                        counter = counter - 1
                                elif add in ('n', 'no', 'N', '', '', ''):
                                        pass
                                else:
                                        print ' !'
                        else:
                                if counterAut > 1:
                                        sys.exit(0)
                                else:
                                        print '    !   !'
                                        counter = counter - 1
                                        counterAut = counterAut + 1
		#   
		elif counter in (8, 9):
                        if answ in ('yes', 'no'):
				docinfo.write(config.record[counter] + answ + '\n')
                        else:
				if counterYN > 1:
                                        sys.exit(0)
                                else:
                                        print '    : yes, no!'
                                        counter = counter - 1
                                        counterYN = counterYN + 1
		#    
		else: 
			if answ == '':
				if counterTrue > 1:
					sys.exit(0)
				else:
					print '    !   !'
					counter = counter - 1
					counterTrue = counterTrue + 1
			else:
				docinfo.write(config.record[counter] + answ + '\n')
		print
		#      
		counter = counter + 1

	print '\n'
	#   :   section
	#
	# : 
	counter = 0
	counterVar = 0
	while counter != len(config.dop_quest):
		print config.help[counter]
		#   
		counterVar = 0
		while counterVar != len(config.answers[counter]):
			temp = config.answers[counter]
			print '\t'+str(counterVar)+') '+temp[counterVar]
			if counter == 1:
				print config.doc_type_help[counterVar]
			if counter == 2:
				print config.sol_type_help[counterVar]
			if counter == 3:
				print config.obj_type_help[counterVar]
			counterVar = counterVar + 1

		sel = raw_input(config.dop_quest[counter])
		# :   ?
		if sel.isdigit() != 1:
			print 'Error!    ,  !'
			counter = counter - 1
		else:
			temp = config.answers[counter]
			docinfo.write('Section: '+temp[string.atoi(sel)]+'\n')
			add = raw_input('    [y/n]? ')
			if add in ('y', 'yes', 'Y', '', '', ''):
				counter = counter - 1
			elif add in ('n', 'no', 'N', '', '', ''):
				pass
			else:
				print ' !'

		counter = counter + 1
		print



	print '\n !'

	#  
	docinfo.close()
	#   
	sys.exit(0)

if __name__ == "__main__":
	main()
